

import json
import psycopg2
import sys
import matplotlib.pyplot as plt
import numpy as np
from src.business_space_adjacent.adjacent import calc_space_adjacent

involved_model_keys = [
    'id',
    'project_id',
    'floor_id',
    'object_type',
    'bim_location',
    'outline'
]

def get_data(sql):
    global connection, cursor
    record = []
    try:
        connection = psycopg2.connect(
            database='datacenter',
            user='postgres',
            password='123456',
            host='192.168.20.236',
            port='5432'
        )
        cursor = connection.cursor()
        cursor.execute(sql)
        record = cursor.fetchall()
    except (Exception, psycopg2.Error) as error:
        print("Error while connecting to PostgreSQL", error)
    finally:
        if connection:
            cursor.close()
            connection.close()
            print('PostgreSQL connection is closed')
    return record

from numpy import *

if __name__ == '__main__':
    # x = [118511.27, 118423.6, 118258.41, 118101.35, 117952.95, 117813.7, 117684.07, 117564.49, 117455.36, 117357.04, 117269.87, 117194.14, 118080.04, 119738.01, 119115.06, 118511.27]
    # y = [23054.67, 23262.08, 23126.16, 22980.93, 22826.85, 22664.46, 22494.29, 22316.92, 22132.93, 21942.94, 21747.59, 21547.53, 19451.69, 20152.51, 21626.26, 23054.67]
    # plt.figure()
    # plt.plot(x, y)
    # plt.pause(1)
    # plt.close()

    # v1 = array([[1, 8], [1, 9]])
    # v2 = array([1, 100])
    # re = linalg.det(v1)
    # print(re)

    involved_model_sql = "SELECT id, project_id, floor_id, object_type, bim_location, outline FROM zone_space_base where project_id = 'Pj1101010015' and outline is not null and floor_id is not null order by floor_id, object_type"
    columns_data = get_data(involved_model_sql)

    model_list = [dict(zip(involved_model_keys, item)) for item in columns_data]

    print(calc_space_adjacent(model_list))

