# -*- coding: utf-8 -*-

import json
import sys

import psycopg2

# from src.level.check_level import check_level_reasonable
import check_level

involved_model_keys = [
    'id',
    'floor_name',
    'project_id',
    'folder_id',
    'fid',
    'accept_time',
    'version',
    'note',
    'user_id',
    'user_name',
    'log',
    'url',
    'md5',
    'status',
    'plan_name',
    'level'
]

level_keys = [
    'id',
    'model_id',
    'name',
    'elevation',
    'last_update',
    'create_time',
    'type',
    'revit_id',
    'source_id',
]
def get_data(sql):
    global connection, cursor
    record = []
    try:
        connection = psycopg2.connect(
            database='datacenter',
            user='postgres',
            password='123qwe!@#',
            host='47.94.89.44',
            port='5432'
        )
        cursor = connection.cursor()
        cursor.execute(sql)
        record = cursor.fetchall()
    except (Exception, psycopg2.Error) as error:
        print("Error while connecting to PostgreSQL", error)
    finally:
        if connection:
            cursor.close()
            connection.close()
            print('PostgreSQL connection is closed')

    return record


def loads(x):
    x['location'] = json.loads(x['location'])
    return x


def loads_curve(x):
    x['curve'] = json.loads(x['curve'])
    return x


if __name__ == '__main__':
    involved_model_sql = "select * from revit.model_floor_file_func('Pj1101120001') where folder_id = " \
                         "'db2476b2612711eab6aa41564c532fd7' and (status in (31, 4)  or fid = 'befee8e262b911ea8ad1ad92633fdd32')"
    columns_data = get_data(involved_model_sql)
    if len(columns_data) == 0:
        sys.exit()
    model_list = [dict(zip(involved_model_keys, item)) for item in columns_data]
    tmpdict = dict()
    tmpdict['id'] = 'test'
    tmpdict['floor_name'] = 'B2M1'
    tmpdict['level'] = -13600.0
    tmpdict['fid'] = 'test'

    # model_list.append(tmpdict)
    level_data = dict()
    for item in model_list:
        level_data[item.get('fid')] = item.get('level')

    print(check_level.check_level_reasonable(model_list))
    print(model_list)