# -*- coding: utf-8 -*-

import json

import psycopg2
from shapely.geometry import Polygon
import sys

from src.grid.check_grid import check_grid_upright

involved_space = [
    'id',
    'floor_name',
    'project_id',
    'folder_id',
    'fid',
    'accept_time',
    'version',
    'note',
    'user_id',
    'user_name',
    'log',
    'url',
    'md5',
    'status'
]

grid_keys = [
    'id',
    'model_id',
    'name',
    'type',
    'last_update',
    'create_time',
    'revit_id',
    'source_id',
    'location',
]


def get_data(sql):
    global connection, cursor
    record = []
    try:
        connection = psycopg2.connect(
            database='datacenter',
            user='postgres',
            password='123456',
            host='192.168.20.234',
            port='5432'
        )
        cursor = connection.cursor()
        cursor.execute(sql)
        record = cursor.fetchall()
    except (Exception, psycopg2.Error) as error:
        print("Error while connecting to PostgreSQL", error)
    finally:
        if connection:
            cursor.close()
            connection.close()
            print('PostgreSQL connection is closed')
    return record


def loads(x):
    x['location'] = json.loads(x['location'])
    return x


def loads_curve(x):
    x['curve'] = json.loads(x['curve'])
    return x


if __name__ == '__main__':
    points1 = [(0, 0), (0, 1), (1, 1), (1, 0)]
    points2 = [(0, 0), (0.00, 0.5), (0, 1), (1, 1), (1, 0)]
    poly1 = Polygon(points1)
    poly2 = Polygon(points2)

    print(poly1.equals(poly2))
    print(poly1.almost_equals(poly2, 0.99))
    print(poly1.almost_equals(poly2, 0))
    print(poly1.almost_equals(poly2, -10))
    print(poly1.almost_equals(poly2, 2))
    print(poly1.almost_equals(poly2, 0.0001))



    # involved_space = "select * from  where folder_id = " \
    #                      "'bbe510dbe26011e999b69b669ea08505' and status in (3, 31, 4) "
    # grid_sql = "select * from revit.grid where model_id = "
    # columns_data = get_data(involved_model_sql)
    #
    # model_list = [dict(zip(involved_model_keys, item)) for item in columns_data]
    # if len(model_list) < 2:
    #     sys.exit()
    # grid_data = dict()
    # for item in model_list:
    #     current_grid_sql = grid_sql + '\'{model_id}\''.format(model_id=item.get('fid'))
    #     single_model_grid = get_data(current_grid_sql)
    #     single_model_grid = [dict(zip(grid_keys, item)) for item in single_model_grid]
    #     grid_data[item.get('fid')] = single_model_grid
    #
    # print(check_grid_upright(model_list, grid_data))

